WHEREIS(1)

NAME
whereis - locate programs

SYNOPSIS
whereis [-abmqsux] [-BMS dir ... -f] program ...

DESCRIPTION
The whereis utility checks the standard binary, manual page, and source directories for the specified programs, printing out the paths of any it finds. The supplied program names are first stripped of leading path name components, any single trailing extension added by gzip(1), compress(1), or bzip2(1), and the leading ‘s.’ or trailing ‘,v’ from a source code control system.

The default path searched is the string returned by the sysctl(8) utility for the “user.cs_path” string, with /usr/libexec, /usr/games and the current user's $PATH appended. Manual pages are searched by default along the $MANPATH. Program sources are located in a list of known standard places, including all the subdirectories of /usr/src and /usr/ports.

The following options are available:

-B  Specify directories to search for binaries. Requires the -f option.

-M  Specify directories to search for manual pages. Requires the -f option.

-S  Specify directories to search for program sources. Requires the -f option.

-a  Report all matches instead of only the first of each requested type.

-b  Search for binaries.

-f  Delimits the list of directories after the -B, -M, or -S options, and indicates the beginning of the program list.

-m  Search for manual pages.

-q  (“quiet”). Suppress the output of the utility name in front of the normal output line. This can become handy for use in a backquote substitution of a shell command line, see EXAMPLES.

-s  Search for source directories.

-u  Search for “unusual” entries. A file is said to be unusual if it does not have at least one entry of each requested type. Only the name of the unusual entry is printed.

-x  Do not use “expensive” tools when searching for source directories. Normally, after unsuccessfully searching all the first-level subdirectories of the source directory list, whereis will ask locate(1) to find the entry on its behalf. Since this can take much longer, it can be turned off with -x.

EXAMPLES
The following finds all utilities under /usr/bin that do not have documentation:

    whereis -m -u /usr/bin/*

Change to the source code directory of ls(1):

    cd `whereis -sq ls`

SEE ALSO
find(1), locate(1), man(1), which(1), sysctl(8)

HISTORY
The whereis utility appeared in 3.0BSD. This version re-implements the historical functionality that was lost in 4.4BSD.

AUTHORS
This implementation of the whereis command was written by Jörg Wunsch.

BUGS
This re-implementation of the whereis utility is not bug-for-bug compatible with historical versions. It is believed to be compatible with the version that was shipping with FreeBSD 2.2 through FreeBSD 4.5 though.

The whereis utility can report some unrelated source entries when the -a option is specified.